<?php
/*
 * ----------------------------------------------------------------------------------
 * Author:	Maverick00
 * Version:	3.0
 * Date:	2014-09-02
 *  
 *
 *Dependency -> TeamRelay.xml	
 *
 * http://teamjtt.xooit.fr/t990-Plugin-TeamRelay.htm#p7905
 */
Aseco::registerEvent('onSync','undef_sync');
Aseco::registerEvent('onStartup', 'trelay_startup');
Aseco::registerEvent('onPlayerFinish', 'trelayjoueurfinish');
Aseco::registerEvent('onPlayerConnect', 'trelay_connect');
Aseco::registerEvent('onBeginMap', 'trelaydebutdelamap');
Aseco::registerEvent('onEndMap', 'trelayfindelamap');
Aseco::registerEvent('onEndRound', 'trelayfinround');
Aseco::registerEvent('onBeginRound', 'trelaydebutround');
Aseco::addChatCommand('teamrelay', 'nom des teams relay');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'clicboutonTeamRelay');
Aseco::registerEvent('onPlayerDisconnect', 'playerquitte');
Aseco::registerEvent("onCheckpoint", "event_checkPoint");
Aseco::registerEvent('onEverySecond', 'trelaysecond');
Aseco::registerEvent('onSync', 'undef_sync');
Aseco::registerEvent('onMenuLoaded', 'teamrelay_menu');
function undef_sync($aseco){
$aseco->plugin_versions[] = array(
      'plugin'   => 'plugin.teamrelay.php',
      'author'   => 'Maverick00',
      'version'   => '3.0'
	);
}
function trelaydebutdelamap($aseco, $data) { global $teamrelay; $teamrelay->trelaydebutdelamap2($aseco, $data); }
function trelayfindelamap($aseco, $data) { global $teamrelay; $teamrelay->trelayfindelamap2($aseco, $data); }
function trelayfinround($aseco) { global $teamrelay; $teamrelay->trelayfinround2($aseco); }
function trelaydebutround($aseco) { global $teamrelay; $teamrelay->trelaydebutround2($aseco); }
function trelayjoueurfinish($aseco, $data) { global $teamrelay; $teamrelay->trelayjoueurfinish2($aseco, $data); }
function trelay_connect($aseco, $data) { global $teamrelay; $teamrelay->trelay_connect2($aseco, $data); }
function playerquitte($aseco, $player) { global $teamrelay; $teamrelay->playerquitte2($aseco, $player); }
function event_checkPoint($aseco, $data) {global $teamrelay; $teamrelay->event_checkPoint2($aseco, $data);}
function clicboutonTeamRelay($aseco, $data) {global $teamrelay; $teamrelay->clicboutonTeamRelay2($aseco, $data);}
function trelaysecond($aseco) {global $teamrelay; $teamrelay->trelaysecond2($aseco);}
function chat_teamrelay($aseco, $command) {global $teamrelay; $teamrelay->chat_teamrelay($aseco, $command);}

function teamrelay_menu($aseco, $menu){
	$menu->addEntry('', 'mainhelpsep', true, 'TeamRelay', 'TRmenu');
	
	$menu->addEntry('TRmenu', '', true, 'Help', 'TR_help', '/teamrelay help', null, null, null, null, 'help');
	
}



function trelay_startup($aseco, $command) {global $aseco, $tabtrelay, $teamrelay, $place, $loginrelay, $nomdesteams, $nbtourfin, $nbsecondes,$pos_scorex,$pos_scorey, $nbtourjoueur, $penaliters, $nbteams, $changenomteams;
	$teamrelay= new teamrelay();
	$teamrelay->aseco = $aseco;
	$place=165000;
	$tabtrelay=array();
	$loginrelay=array();
	for ($i = 0; $i <9; $i++){
		for ($j=1; $j<4; $j++){
			$tabtrelay[($i*10+$j)]['login']='';
			$tabtrelay[($i*10+$j)]['nick']='';
			$tabtrelay[($i*10+$j)]['finwu']=0;
			$tabtrelay[($i*10+$j)]['enjeu']=0;
			$tabtrelay[($i*10+$j)]['nbtourjoueur']=0;
		}
		$tabtrelay[$i]['nbcp']=0;
		$tabtrelay[$i]['tour']=0;
		$tabtrelay[$i]['gagne']=0;
		$tabtrelay[$i]['temps']=0;
		$tabtrelay[$i]['tempstotal']=0;
		$tabtrelay[$i]['nbteams']=0;
		$tabtrelay[$i]['restart']=0;
	}
	$aseco->client->query('SetAllWarmUpDuration', 2);
	$aseco->client->query('SetTimeAttackLimit',0);
	$aseco->client->query('SetMaxSpectators',100);
    if(file_exists('TeamRelay.xml')){
		$conf_file = 'TeamRelay.xml';
		if ($xml = $aseco->xml_parser->parseXml($conf_file)) {
			$id=1;
			foreach ($xml['TEAMRELAY']['TEAMS'][0]['TEAM'] as $team) {
				$nomdesteams[$id]=$team;
				$id++;
			}
			$nbtourfin=$xml['TEAMRELAY']['TOURS'][0]['TOUR'][0];
			$nbtourjoueur=$xml['TEAMRELAY']['TOURS'][0]['TOURJOUEUR'][0];
			$penaliters=$xml['TEAMRELAY']['TOURS'][0]['PENALITERS'][0];
			$nbsecondes['finmap']=$xml['TEAMRELAY']['FINS'][0]['FINMAP'][0];
			$nbsecondes['finscores']=$xml['TEAMRELAY']['FINS'][0]['FINSCORES'][0];
			$pos_scorex=$xml['TEAMRELAY']['POSS'][0]['POS_SCOREX'][0];
			$pos_scorey=$xml['TEAMRELAY']['POSS'][0]['POS_SCOREY'][0];
			$nbteams=$xml['TEAMRELAY']['TOURS'][0]['NBTEAMS'][0];
			$changenomteams=$xml['TEAMRELAY']['TOURS'][0]['CHANGENOMTEAMS'][0];
		}
			 if ($nbteams>8){
						$nbteams=8;
				   }
				    if ($nbteams<2){
						$nbteams=2;
				   }
	}
} 
class teamrelay	{public $aseco;
	function trelaysecond2($aseco) {global $aseco, $tabtrelay, $teamrelay, $nomdesteams, $nbsecondes;
		if ($tabtrelay[0]['gagne']!=0){
			if($nbsecondes['finmap']>$nbsecondes['compteur1']){
				
					$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id="6612111112288882">
						<frame posn="-25 35 0">
							<quad sizen="50 4.4" posn="25 0 0.001" halign="center" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
							<label posn="25 -1.1 0.001" halign="center" sizen="50 3"  textsize="3.6" text="Une team a fini. Temps pour terminer : '.($nbsecondes['finmap']-$nbsecondes['compteur1']-1).' s" style="TextRaceChat"/>
						</frame></manialink></manialinks>';
					$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));	
					$tabtrelay[0]['login']='';	
					if ($tabtrelay[0]['gagne']==99){
						$nbsecondes['compteur1']=$nbsecondes['finmap']-1;
					}
				$nbsecondes['compteur1']++;
				} else {
				foreach ($aseco->server->players->player_list as $player) {
					$this->setSpectator($player->login,1);
				}
				$nbsecondes['compteur2']++;
				$xml = '<manialinks><manialink id="65691111191"></manialink><manialink id="6612111112288882"></manialink>
				</manialinks>';	
				$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));	
				$teamrelay->trelayaffichagefin($aseco);
				if($nbsecondes['finscores']<$nbsecondes['compteur2']){
					$aseco->client->query('NextMap');
				}	
			}
		}
	}
	function clicboutonTeamRelay2($aseco, $command) {global $aseco, $tabtrelay, $teamrelay, $loginrelay, $nomdesteams;
	   	$login = $command[1];
		$aseco->client->query('GetPlayerInfo', $login, 1);
		$player = $aseco->client->getResponse();
		$action = $command[2].'';
		if ($action >165010 && $action<165086){
		  $num=$action-165000;
		  if ($loginrelay[$login]!=0) {
			$tabtrelay[$loginrelay[$login]]['login']='';
			$tabtrelay[$loginrelay[$login]]['nick']='';
			$tabtrelay[$loginrelay[$login]]['enjeu']=0;
		  }
		  $tabtrelay[$num]['login']=$login;//$player['NickName'];
		  $tabtrelay[$num]['nick']=$player['NickName'];
		  $loginrelay[$login]=$num;
		  $teamrelay->trelayaffichagehaut($aseco);
		  $teamrelay->trelayaffichageboutons($aseco, $login);
		}
		if ($action ==165100){
			if ($tabtrelay[($loginrelay[$login])]['enjeu']==1){	 
				$colonnejoueur=round($loginrelay[$login]/10);
				$nbjcol=$loginrelay[$login]-$colonnejoueur*10;
				for ($i = 1; $i <4; $i++){
					if ($nbjcol==3){
						$nbjcol=1;
					}
					else {
						$nbjcol++;
					}
						if ( isset($aseco->server->players->player_list[$tabtrelay[($colonnejoueur*10+$nbjcol)]['login']]) ) {
						$this->setSpectator($tabtrelay[($colonnejoueur*10+$nbjcol)]['login'],2);
						$tabtrelay[($colonnejoueur*10+$nbjcol)]['enjeu']=1;
						break;
						}	
				}
			}	
			$tabtrelay[$loginrelay[$login]]['login']='';
			$tabtrelay[$loginrelay[$login]]['nick']='';
			$tabtrelay[$loginrelay[$login]]['enjeu']=0;
			$tabtrelay[$loginrelay[$login]]['finwu']=0;
			$loginrelay[$login]=0;
			$teamrelay->trelayaffichagehaut($aseco);
			$teamrelay->trelayaffichageboutons($aseco, $login);
		}
		if ($action ==165101){
			if ($tabtrelay[$loginrelay[$login]]['finwu']==1){
				$tabtrelay[$loginrelay[$login]]['finwu']=0;
				} else {
				$tabtrelay[$loginrelay[$login]]['finwu']=1;
			}
			$comptejoueur=0;
			$comptefinwu=0;
			for ($i = 1; $i <9; $i++){
				for ($j = 1; $j <4; $j++){
						if ( isset($aseco->server->players->player_list[$tabtrelay[($i*10+$j)]['login']])) {
						$comptejoueur++;
							if ($tabtrelay[($i*10+$j)]['finwu']==1){
								$comptefinwu++;
							}
						}	
				}
			}	
			if ($comptejoueur==$comptefinwu){
				$aseco->client->query('RestartMap');
			}
			$teamrelay->trelayaffichagehaut($aseco);
			$teamrelay->trelayaffichageboutons($aseco, $login);	
		}
		if ($action >170000 && $action <170086){
			$this->aseco->client->addCall('ForceSpectatorTarget', array($login, $tabtrelay[($action-170000)]['login'], -1));	
		}
	}
	function chat_teamrelay($aseco, $command) {global $teamrelay, $aseco, $nbtourfin, $nbtourjoueur, $penaliters, $nbteams, $tabtrelay, $loginrelay, $nomdesteams, $changenomteams;
		$admin = $command['author'];
        $login = $admin->login;
        $nick = $admin->nickname;
		if($aseco->isMasterAdmin($admin) || $aseco->isAdmin($admin)) {
			$cmd = explode(' ', $command['params']);
			$msg='';
			if($cmd[0] == 'start') {
				$aseco->client->query('SetAllWarmUpDuration', 2);
				$aseco->client->query('SetTimeAttackLimit',0);
				$aseco->client->query('SetMaxSpectators',100);
				 $tabtrelay=array();
				  $loginrelay=array();
				  $aseco->client->query('NextMap');
						$msg = 'Le relay est configure';
			}
			if($cmd[0] == 'nbtour') {
				if(is_numeric($cmd[1])) {
				   $nbtourfin=$cmd[1];
						$msg = 'Le nombre de tours pour gagner est : '. $nbtourfin;
						$teamrelay->trelayaffichagescores($aseco);
				}else {
                    $msg = 'Le nombre de tours pour gagner doit etre un nombre entier!';
                }
			}
			if($cmd[0] == 'nbtourjoueur') {
				if(is_numeric($cmd[1])) {
				   $nbtourjoueur=$cmd[1];
						$msg = 'Le nombre de tours de chaque joueur est : '. $nbtourjoueur;
						
				}else {
                    $msg = 'Le nombre de tours pour chaque joueur doit etre un nombre entier!';
                }
			}
			if($cmd[0] == 'penaliters') {
				if(is_numeric($cmd[1])) {
				   $penaliters=$cmd[1];
						$msg = 'La penalite pour un restart est : '.($penaliters/1000).' s';
						
				}else {
                    $msg = 'La penalite doit etre un nombre entier!';
                }
			}
			if($cmd[0] == 'nbteams') {
				if(is_numeric($cmd[1])) {
				   $nbteams=$cmd[1];
				   if ($nbteams>8){
						$nbteams=8;
				   }
				    if ($nbteams<2){
						$nbteams=2;
				   }
						$msg = 'Le nombre de teams est : '.($nbteams);
						$teamrelay->trelayaffichagescores($aseco);
						$tabtrelay=array();
						$loginrelay=array();
						$aseco->client->query('NextMap');
				}else {
                    $msg = 'Le nombre de teams doit etre un nombre entier!';
                }
			}
			if($cmd[0] == 'help') {
               		$header = '{#black}/teamrelay$g will manage your TeamRelay Plugin:';
					$help = array();
					$help[] = array('Welcome to the TeamRelay- Plugin Help.');
					$help[] = array('The current running version is 1.1');
					$help[] = array('If you have problems or suggestions, please post it in the $l[http://teamjtt.xooit.fr/t1044-Plugin-mode-relay.htm#p8126');
					$help[] = array('');
					$help[] = array('...', '{#black}help',
									'Displays this help information');
					$help[] = array('...', '{#black}start',
									'Initialise le plugin');
					$help[] = array('...', '{#black}nbtour',
									'Set the number of laps to win');
					$help[] = array('...', '{#black}nbtourjoueur',
									'Set the number of laps in sequence to one player');
					$help[] = array('...', '{#black}nbteams',
									'Set the number of the teams');
					$help[] = array('...', '{#black}nomteam {1 ... 8} {nameteam}',
									'Set the name of the team');
					$help[] = array('...', '{#black}changenomteams {true|false}',
									'Enable to change the name of the team');
					$help[] = array('...', '{#black}penaliters',
									'Set the number of milliseconds to the penalty for restart 1000=one seconde');
					
					display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.2, 0.05, 0.35, 0.8), 'OK');
				
				
			}
			if($cmd[0] == 'changenomteams') {
				
				   $changenomteams=$cmd[1];
						$msg = 'Le changement des teams est en '.$cmd[1];
						
				
			}
			if($cmd[0] == 'nomteam'){
			if(is_numeric($cmd[1]) && $cmd[1]>0 && $cmd[1]<9) {
			$nom=$cmd[2];
				
					$nomdesteams[$cmd[1]]=$nom;
					$teamrelay->trelayaffichagehaut($aseco);
					$teamrelay->trelayaffichagescores($aseco);
					 $msg = 'Changement du nom de la team '.$cmd[1].' en '.$cmd[2];
				
			}
			}
			if ($msg!='') {
				$aseco->client->query('ChatSendServerMessageToLogin', $msg, $login);
			}
		}
		else {
			$cmd = explode(' ', $command['params']);
			$msg='';
			if($cmd[0] == 'help') {
               		$header = '{#black}/teamrelay$g will manage your TeamRelay Plugin:';
					$help = array();
					$help[] = array('Welcome to the TeamRelay- Plugin Help.');
					$help[] = array('The current running version is 1.1');
					$help[] = array('If you have problems or suggestions, please post it in the $l[http://teamjtt.xooit.fr/t1044-Plugin-mode-relay.htm#p8126');
					$help[] = array('');
					$help[] = array('...', '{#black}help',
									'Displays this help information');
					$help[] = array('...', '{#black}nomteam',
									'Set the name of the team');
					
					
					display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.2, 0.05, 0.35, 0.8), 'OK');
				
				
			}
			if($cmd[0] == 'nomteam'){
			$nom=$cmd[1];
				 if ($loginrelay[$login]!=0 && $changenomteams=='true') {
					$nomdesteams[(round($loginrelay[$login]/10))]=$nom;
					$teamrelay->trelayaffichagehaut($aseco);
					$teamrelay->trelayaffichagescores($aseco);
					 $msg = 'Changement du nom de la team';
				}
			}
			if ($msg!='') {
				$aseco->client->query('ChatSendServerMessageToLogin', $msg, $login);
			}
		}
	}
	function trelay_connect2($aseco, $player) {global $teamrelay, $loginrelay, $aseco, $tabtrelay;
		$login=$player->login;
		$loginrelay[$login]=0;
		$aseco->client->query('GetWarmUp');
		$inwu = $aseco->client->getResponse();
		$personne=0;
		if ($inwu!=1) {
			//$this->setSpectator($login,1);
			for ($i = 1; $i <9; $i++){
				for ($j = 1; $j <4; $j++){
					if ( $login==$tabtrelay[($i*10+$j)]['login'] ) {
						$loginrelay[$login]=$i*10+$j;
						$colonnejoueur=round($loginrelay[$login]/10);
						if ($tabtrelay[$colonnejoueur]['gagne']!=0) return;
						$nbjcol=$loginrelay[$login]-$colonnejoueur*10;
						$joueuron=0;
						$personne=1;
						for ($k = 1; $k <4; $k++){
							if ($nbjcol==3){
								$nbjcol=1;
								} else {
								$nbjcol++;
							}
							if ($tabtrelay[($colonnejoueur*10+$nbjcol)]['enjeu']==1) {
								$joueuron=1;
								$i=9;
								$j=4;
								break;
							}
						}
						if ($loginrelay[$login]!=0 && $joueuron==0) {
							$this->setSpectator($login,2);
							$tabtrelay[($loginrelay[$login])]['enjeu']=1;
							$joueuron=1;
						}
						$i=9;
						break;
					}
				}
			}	
			if ($personne==0) {
				for ($i = 1; $i <9; $i++){
					for ($j = 1; $j <4; $j++){
							if ( isset($aseco->server->players->player_list[$tabtrelay[($i*10+$j)]['login']]) ) {
								$personne=1;
								$i=9;
							break;
							}	
					}
				}	
			}
			if ($personne==0) {
				$aseco->client->query('NextMap');
			}
		}	
		$teamrelay->trelayaffichagehaut($aseco);	
		$teamrelay->trelayaffichageboutons($aseco, $login);	
	}
	function playerquitte2($aseco, $player){global $teamrelay, $loginrelay, $tabtrelay, $aseco;
		$login=$player->login;
		$aseco->client->query('GetWarmUp');
		$inwu = $aseco->client->getResponse();
		if ($inwu==1) {
			$tabtrelay[$loginrelay[$login]]['login']='';
			$tabtrelay[$loginrelay[$login]]['nick']='';
			$tabtrelay[$loginrelay[$login]]['finwu']=0;
			$loginrelay[$login]=0;
			} else {
				if ($tabtrelay[($loginrelay[$login])]['enjeu']==1){	 
					$colonnejoueur=round($loginrelay[$login]/10);
					if ($tabtrelay[$colonnejoueur]['gagne']!=0) return;
						$nbjcol=$loginrelay[$login]-$colonnejoueur*10;
						for ($i = 1; $i <4; $i++){
							if ($nbjcol==3){
								$nbjcol=1;
								} else {
								$nbjcol++;
							}
							if ( isset($aseco->server->players->player_list[$tabtrelay[($colonnejoueur*10+$nbjcol)]['login']]) ) {
								$this->setSpectator($tabtrelay[($colonnejoueur*10+$nbjcol)]['login'],2);
								$tabtrelay[($colonnejoueur*10+$nbjcol)]['enjeu']=1;
								break;
							}	
						}
				}	
		}
		$tabtrelay[($loginrelay[$login])]['enjeu']=0;
		$teamrelay->trelayaffichagehaut($aseco);
	}	
	function trelaydebutdelamap2($aseco) {global $teamrelay, $aseco, $nbsecondes, $tabtrelay;
		for ($i = 0; $i <9; $i++) {
			$tabtrelay[$i]['nbcp']=0;
			$tabtrelay[$i]['tour']=0;
			$tabtrelay[$i]['gagne']=0;
			$tabtrelay[$i]['temps']=0;
			$tabtrelay[$i]['tempstotal']=0;
			$tabtrelay[$i]['nbteams']=0;
			$tabtrelay[$i]['restart']=0;
		}
		$nbsecondes['compteur1']=0;
		$nbsecondes['compteur2']=0;
		foreach ($aseco->server->players->player_list as $player) {
			$this->setSpectator($player->login,2);
		}
		$teamrelay->trelayaffichageaccueil($aseco);
		$teamrelay->trelayaffichagescores($aseco);
	}
	function trelayfindelamap2($aseco){global $teamrelay, $loginrelay, $tabtrelay, $aseco;
		for ($i = 1; $i <9; $i++){
			for ($j = 1; $j <4; $j++){
				if (!isset($aseco->server->players->player_list[$tabtrelay[($i*10+$j)]['login']]) && ($tabtrelay[($i*10+$j)]['login']!='')) {
					$loginrelay[$login]=0;
					$tabtrelay[($i*10+$j)]['nick']='';
					$tabtrelay[($i*10+$j)]['login']='';
				}
			}
		}
		$tabtrelay[0]['gagne']=0;
		$teamrelay->trelayaffichagehaut($aseco);
		$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id="656925242691"></manialink></manialinks>';
		$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false)); 
	}
	function trelaydebutround2($aseco) {global $teamrelay, $aseco;
		$teamrelay->trelayaffichagehaut($aseco);
		foreach ($aseco->server->players->player_list as $player) {
			$teamrelay->trelayaffichageboutons($aseco, $player->login);
		}
	}
	function trelayfinround2($aseco) {global $teamrelay, $tabtrelay, $aseco;
		$aseco->client->query('GetWarmUp');
		$inwu = $aseco->client->getResponse();
		if ($inwu!=1) {
			foreach ($aseco->server->players->player_list as $player) {
				$this->setSpectator($player->login,1);
			}
			for ($i = 1; $i <9; $i++){
				for ($j = 1; $j <4; $j++){
					if ($tabtrelay[($i*10+$j)]['login']!=''){
						$tabtrelay[($i*10+$j)]['enjeu']=0;
						$tabtrelay[($i*10+$j)]['finwu']=0;
						$tabtrelay[($i*10+$j)]['enjeu']=0;
						$tabtrelay[($i*10+$j)]['nbtourjoueur']=0;
					}
				}
			}
			for ($i = 1; $i <9; $i++){
				for ($j = 1; $j <4; $j++){
						if ( isset($aseco->server->players->player_list[$tabtrelay[($i*10+$j)]['login']]) ) {
						$this->setSpectator($tabtrelay[($i*10+$j)]['login'],2);
						$tabtrelay[($i*10+$j)]['enjeu']=1;
						$tabtrelay[0]['nbteams']++;
						break;
						}	
				}
			}	
		}
		$teamrelay->trelayaffichagehaut($aseco);
	}
	function trelayjoueurfinish2($aseco, $finish){global $teamrelay, $loginrelay, $nbtourfin, $nomdesteams, $tabtrelay, $aseco, $nbtourjoueur, $penaliters, $tempscp;
		$login=$finish->player->login;
		$score=$finish->score;
		$colonnejoueur=round($loginrelay[$login]/10);
		$tabtrelay[$colonnejoueur]['restart']++;
		if($score==0) {
			$tabtrelay[$colonnejoueur]['nbcp']=($tabtrelay[$colonnejoueur]['tour'])*($aseco->server->map->nbchecks);
			
			if ($tabtrelay[$colonnejoueur]['restart']>2){
				$tabtrelay[$colonnejoueur]['tempstotal']=($tabtrelay[$colonnejoueur]['tempstotal'])+$tempscp+$penaliters;
				$tempscp=0;
			}
		}
		if ($loginrelay[$login]==0) {
			$this->setSpectator($login,1);			
			} else {
				if ($tabtrelay[($loginrelay[$login])]['enjeu']==0) {
					$this->setSpectator($login,1);
				}
				$nbjcol=$loginrelay[$login]-$colonnejoueur*10;
				if($score!=0) {
					$tabtrelay[$colonnejoueur]['restart']=0;
					$tabtrelay[$colonnejoueur]['tempstotal']=($tabtrelay[$colonnejoueur]['tempstotal'])+$score;
					$tabtrelay[$colonnejoueur]['temps']=$tabtrelay[$colonnejoueur]['tempstotal'];
					$tabtrelay[$colonnejoueur]['tour']++;
					$tabtrelay[($loginrelay[$login])]['nbtourjoueur']++;
					if ($tabtrelay[($loginrelay[$login])]['nbtourjoueur']<$nbtourjoueur){
						$teamrelay->trelayaffichagescores($aseco);
						return;
					} else {
						$tabtrelay[($loginrelay[$login])]['nbtourjoueur']=0;
					}
					$this->setSpectator($login,1);
					$tabtrelay[($loginrelay[$login])]['enjeu']=0;
					if ($tabtrelay[$colonnejoueur]['tour']==$nbtourfin){
						$tabtrelay[0]['gagne']=$tabtrelay[0]['gagne']+1;
						if ($tabtrelay[0]['nbteams']==$tabtrelay[0]['gagne']){
							$tabtrelay[0]['gagne']=99;
						}
						$tabtrelay[0]['login']=$login;
						$tabtrelay[$colonnejoueur]['gagne']=1;
					}
					for ($i = 1; $i <4; $i++){
						if ($nbjcol==3){
							$nbjcol=1;
							} else {
							$nbjcol++;
						}
						if ( isset($aseco->server->players->player_list[$tabtrelay[($colonnejoueur*10+$nbjcol)]['login']]) && $tabtrelay[$colonnejoueur]['gagne']!=1) {
							$this->setSpectator($tabtrelay[($colonnejoueur*10+$nbjcol)]['login'],2);
							$tabtrelay[($colonnejoueur*10+$nbjcol)]['enjeu']=1;
							break;
						}	
					}
				}
		}		
	$teamrelay->trelayaffichagehaut($aseco);
	$teamrelay->trelayaffichagescores($aseco);
	}
	function event_checkPoint2($aseco, $checkpt) {global $teamrelay, $loginrelay, $tabtrelay, $tempscp;
		$login = $checkpt[1];	
		$tempscp=$checkpt[2];	
		if ($loginrelay[$login]!=0 && $tabtrelay[($loginrelay[$login])]['enjeu']!=0){
			$colonnejoueur=round($loginrelay[$login]/10);
			$tabtrelay[$colonnejoueur]['nbcp']++;
			$tabtrelay[$colonnejoueur]['temps']=($tabtrelay[$colonnejoueur]['tempstotal'])+$tempscp;
			$teamrelay->trelayaffichagescores($aseco);
		}
	}
	function setSpectator($login,$mode) {
		$this->aseco->addCall('ForceSpectator', array($login, $mode));	
	}
	function trelayaffichageaccueil($aseco){
		$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id="6849819849849">
			<frame posn="-54 47 0">
				<quad sizen="96 8.2" posn="0 0 0.001" style="BgsPlayerCard" substyle="BgCardSystem"/>
				<label posn="48 -1 0.001" halign="center" sizen="96 4"  textsize="4" text="Serveur en mode relay" style="TextTitle2Blink"/>
				<label posn="48 -4 0.001" halign="center" sizen="96 4"  textsize="4" text="Choisissez une team pendant le Warmup" style="TextRaceChat"/>
			</frame></manialink></manialinks>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
	}
	function trelayaffichageboutons($aseco, $login){global $teamrelay, $loginrelay, $tabtrelay, $aseco;
		$aseco->client->query('GetWarmUp');
		$inwu = $aseco->client->getResponse();
		$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id="1323542352432">
			<frame posn="-64 32 0">
				<quad sizen="12 3.6" posn="0 0 0.001" style="BgsPlayerCard" substyle="BgCardSystem"/>
				<label posn="5.8 -1 0.001" halign="center" sizen="11.6 2"  textsize="2" text="Quitter la team" action="165100"/>';
				if ($loginrelay[$login]!=0 && $inwu==1){
					if($tabtrelay[$loginrelay[$login]]['finwu']==0){
						$xml.='<quad sizen="12 3.6" posn="0 -6 0.001" style="BgsPlayerCard" substyle="BgCardSystem"/>
						<label posn="5.8 -6.8 0.001" halign="center" sizen="11.6 2"  textsize="2" text="Click to stop WU" action="165101"/>';
						} else {
						$xml.='<quad sizen="12 3.6" posn="0 -6 0.001" style="BgRaceScore2" substyle="CupFinisher"/>
						<label posn="5.8 -6.8 0.001" halign="center" sizen="11.6 2"  textsize="2" text="Click to stay in WU" action="165101"/>';
					}
				}
			$xml.='</frame></manialink></manialinks>';
		$aseco->client->addCall("SendDisplayManialinkPageToLogin", array($login,$xml, 0, false));
	}
	function trelayaffichagehaut($aseco){global $teamrelay, $loginrelay, $nomdesteams, $tabtrelay, $place, $nbteams;
		$aseco->client->query('GetWarmUp');
		$inwu = $aseco->client->getResponse();
		$posframe=-$nbteams*6.75;
		$posquad=$nbteams*12;
		if ($inwu==1) {
			$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id="6849819849849">
			<frame posn="'.$posframe.' 48 0">
				<quad sizen="'.$posquad.' 12.4" posn="0 0 0.001" style="BgsPlayerCard" substyle="BgCardSystem"/>';
				for ($i = 0; $i <$nbteams; $i++){
					$posx=6.2+$i*11.9;
					$xml.='<quad sizen="11.6 11.8" halign="center" posn="'.$posx.' -0.3 0.001"  style="BgsPlayerCard" substyle="BgCardSystem"/>
					<quad sizen="11.6 3.2" halign="center" posn="'.$posx.' -0.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
					<label posn="'.$posx.' -1.2 0.001" halign="center" sizen="9 2"  textsize="2" text="'.$nomdesteams[($i+1)].'"/>';
					for ($j = 0; $j <3; $j++){
						$posy=-3.8-$j*2.7;
						$posyy=$posy-0.3;
						$num=10*($i+1)+$j+1;
						$nom=$tabtrelay[$num]['nick'];
						if ($nom=='') {
							$xml.='<quad halign="center" posn="'.$posx.' '.$posy.' 0.001" sizen="11 2.2" style="BgsChallengeMedals" substyle="BgNotPlayed" />
							<label posn="'.$posx.' '.$posyy.' 0.001" halign="center" sizen="9 1"  textsize="1" text="--> $0f0free place $fff<--" action="'.($place+10*($i+1)+$j+1).'"/>';
						}
						else {
							if ($loginrelay[$tabtrelay[$num]['login']]!=0){
								$posxx=$posx-4.8;
								$posxxx=$posx-5.2;
								if($tabtrelay[$num]['finwu']==0){
									$xml.='<quad halign="center" sizen="2.2 2.4" posn="'.$posxx.' '.$posy.' 0.001" style="BgRaceScore2" substyle="Warmup" />';	
								}
								else {
									$xml.='<quad halign="center" sizen="2.2 2.2" posn="'.$posxxx.' '.$posy.' 0.001"style="Icons64x64_1" substyle="StateSuggested" />';
								}
							}
							$xml.='<label posn="'.$posx.' '.$posyy.' 0.001" halign="center" sizen="9 1"  textsize="1" text="'.$nom.'"/>';
						}
					}
				}
			$xml.='</frame></manialink></manialinks>';
		}
		else {
			$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id="6849819849849">
				<frame posn="'.$posframe.' 48 0">
					<quad sizen="'.$posquad.' 10.5" posn="0 0 0.001" style="BgsPlayerCard" substyle="BgCardSystem"/>';
					for ($i = 0; $i <$nbteams; $i++)
					{
						$posx=6.2+$i*11.9;
						$xml.='<quad sizen="11.6 3.6" halign="center" posn="'.$posx.' -0.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
						<label posn="'.$posx.' -1.2 0.001" halign="center" sizen="9 2"  textsize="3" text="'.$nomdesteams[($i+1)].'"/>';
							for ($k = 0; $k<3; $k++){
								$num=10*($i+1)+$k+1;
								$nom=$tabtrelay[$num]['nick'];
								$posy=-2-$k*2;
								$posyyy=$posy-2.1;
								$posyy=$posy-2.4;
								if ($tabtrelay[$num]['enjeu']==1){
									$xml.='<quad halign="center" posn="'.$posx.' '.$posyyy.' 0.001" sizen="10.4 1.8" style="BgRaceScore2" substyle="CupFinisher" />
									<quad halign="center" posn="'.$posx.' '.$posyyy.' 0.001" sizen="11 2.2" style="BgsChallengeMedals" substyle="BgNotPlayed" />';
									$xml.='<label posn="'.$posx.' '.$posyy.' 0.001" halign="center" sizen="9 2"  textsize="1" text="'.$nom.'" action="'.(170000+$num).'"/>';  
								} else {
									$xml.='<label posn="'.$posx.' '.$posyy.' 0.001" halign="center" sizen="9 2"  textsize="1" text="'.$nom.'"/>';
								}
							}
					}
			$xml.='</frame></manialink></manialinks>';
		}
		$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
	}	
	function trelayaffichagescores($aseco){global $teamrelay, $nomdesteams, $nbtourfin, $tabtrelay,$pos_scorex,$pos_scorey, $nbteams;
	$posquad=3*$nbteams+3;
	$xml = '<manialinks><manialink id="65691111191">
		<frame posn="'.$pos_scorex.' '.$pos_scorey.' 0">
			<quad sizen="20 '.$posquad.'"  style="BgsPlayerCard" substyle="BgCardSystem"/>
			<quad sizen="9 2.4" posn="2 -0.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="8.6 1.6" posn="6.5 -0.6 0.001" halign="center" textsize="2.2" text="Teams" style="TextRaceChat"/>
			<quad sizen="4.6 2.4" posn="10.8 -0.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="3.6 1.6" posn="13.2 -0.6 0.001" halign="center" textsize="2" text="Laps" style="TextRaceChat"/>
			<quad sizen="4 2.4" posn="15.6 -0.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="3 1.6" posn="17.7 -0.6 0.001" halign="center" textsize="2" text="Cps" style="TextRaceChat"/>';
			for ($i = 1; $i <($nbteams+1); $i++){
				$position[$i]=($tabtrelay[$i]['tour'])*1000000000+($tabtrelay[$i]['nbcp'])*1000000-($tabtrelay[$i]['temps'])*0.001;
			}
			arsort($position);
			$i=1;
			foreach ($position as $key=>$val) {
				
				$posy=-1.3-$i*2.8;
				$xml .= '<label posn="1 '.$posy.' 0.001"  sizen="1.6 2" halign="center" textsize="1" text="# '.$i.'" style="TextCreditsTitle"/>
					<label posn="6.5 '.$posy.' 0.001"  sizen="8.6 2" halign="center" textsize="2" text="'.$nomdesteams[$key].'"/>
					<label posn="13.2 '.$posy.' 0.001"  sizen="3.6 2" halign="center" textsize="2" text="'.$tabtrelay[$key]['tour'].'" style="StyleValueYellowSmall"/>
					<label posn="17.7 '.$posy.' 0.001"  sizen="3 2" halign="center" textsize="2" text="'.$tabtrelay[$key]['nbcp'].'" style="TextRaceChronoOfficial"/>';
				$i++;
			}
			$posquad=-3*$nbteams-3.4;
			$xml .= '<quad posn="0 '.$posquad.' 0.001"  sizen="16 2.4"  style="BgsPlayerCard" substyle="BgCardSystem"/>
			<label posn="2 '.($posquad-0.4).' 0.001"  sizen="12 2" textsize="1" text=" Laps to finish : " style="TextCreditsTitle"/> 
			<label posn="13.2 '.($posquad-0.4).' 0.001"  sizen="3.6 2" halign="center" textsize="2" text="'.$nbtourfin.'" style="StyleValueYellowSmall"/>
		</frame></manialink></manialinks>';
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false)); 
	}
	
	
	function trelayaffichagefin($aseco){global $teamrelay, $nomdesteams, $nbtourfin, $tabtrelay, $nbteams;
	$xml = '<manialinks><manialink id="656925242691">
		<frame posn="-25 25 0">
			<quad sizen="50 54"  style="BgsPlayerCard" substyle="BgCardSystem"/>
			<quad sizen="6 6" posn="13.5 -0.6 0.001" halign="center" style="Icons128x128_1" substyle="Buddies"/>
			<quad sizen="18 4.4" posn="4.5 -6.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="18 1.6" posn="13.5 -7 0.001" halign="center" textsize="5" text="Teams" style="TextRaceChat"/>
			<quad sizen="6 6" posn="26.6 -0.6 0.001" halign="center" style="BgRaceScore2" substyle="Laps"/>
			<quad sizen="9.2 4.4" posn="22 -6.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="9.2 1.6" posn="26.6 -7 0.001" halign="center" textsize="4" text="Laps" style="TextRaceChat"/>
			<quad sizen="6 6" posn="34.6 -0.6 0.001"halign="center"  style="Icons128x128_1" substyle="Race"/>
			<quad sizen="8 4.4" posn="30.6 -6.4 0.001" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="8 1.6" posn="34.6 -7 0.001" halign="center" textsize="4" text="Cps" style="TextRaceChat"/>
			<quad sizen="6 6" posn="44.4 -0.6 0.001" halign="center" style="BgRaceScore2" substyle="SendScore"/>
			<quad sizen="9.2 4.4" posn="44.4 -6.4 0.001" halign="center" style="UiSMSpectatorScoreBig" substyle="PlayerIconBg"/>
			<label sizen="8.8 1.6" posn="44.4 -7 0.001" halign="center" textsize="4" text="Time" style="TextRaceChat"/>';
			for ($i = 1; $i <($nbteams+1); $i++){
				$position[$i]=($tabtrelay[$i]['tour'])*1000000000+($tabtrelay[$i]['nbcp'])*1000000-($tabtrelay[$i]['tempstotal'])*0.001;
			}
			arsort($position);
			$i=1;
			foreach ($position as $key=>$val) {
				$posy=-8-$i*5;
				if ($i==1){
					$xml .= '<quad posn="2.2 '.($posy+0.8).' 0.001"  sizen="4.8 4.8" halign="center" style="Icons64x64_1" substyle="First"/>';
					} else {
					if ($i==2){
						$xml .= '<quad posn="2.2 '.($posy+0.8).' 0.001"  sizen="4.8 4.8" halign="center" style="Icons64x64_1" substyle="Second"/>';
						} else {
						if ($i==3){
							$xml .= '<quad posn="2.2 '.($posy+0.8).' 0.001"  sizen="4.8 4.8" halign="center" style="Icons64x64_1" substyle="Third"/>';
							} else {
							$xml .= '<label posn="2.2 '.($posy-0.6).' 0.001"  sizen="4.1 2" halign="center" textsize="2" text="# '.$i.'" style="TextCreditsTitle"/>';
						}
					}
				}			
					$xml .= '<label posn="13.5 '.$posy.' 0.001"  sizen="18 4" halign="center" textsize="5" text="'.$nomdesteams[$key].'"/>
					<label posn="26.6 '.$posy.' 0.001"  sizen="9.2 4" halign="center" textsize="4" text="'.$tabtrelay[$key]['tour'].'" style="StyleValueYellowSmall"/>
					<label posn="34.6 '.$posy.' 0.001"  sizen="8 4" halign="center" textsize="4" text="'.$tabtrelay[$key]['nbcp'].'" style="TextRaceChronoOfficial"/>
					<label posn="44.4 '.($posy-0.6).' 0.001"  sizen="8 4" halign="center" textsize="2 
					" text="'.formatTime($tabtrelay[$key]['tempstotal']).'" style="TextRaceChronoOfficial"/>';
				$i++;
			}
		$xml .= '</frame></manialink></manialinks>';
		$aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false)); 
	}
}
?>